// compiler_extensions.h
//
// Created 1999 by Jouni Seppnen
//
// $Id: compiler-extensions.h,v 1.1 1999/08/03 09:24:41 jks Exp $
//

#ifndef __COMPILER_EXTENSIONS__
#define __COMPILER_EXTENSIONS__

// This header file defines macros that expand to GCC extensions when
// compiled on GCC, and nothing when compiled on another compiler.
// (In principle, if we use another compiler at some time, we might
// add macros for that compiler's extensions in this header file.)

#ifdef __GNUC__

#define GCC_NORETURN		__attribute__((__noreturn__))
#define GCC_FORMAT(a,b,c)	__attribute__((__format__(a,b,c)))
#define GCC_UNUSED		__attribute__((__unused__))

#else

#define GCC_NORETURN
#define GCC_FORMAT(a,b,c)
#define GCC_UNUSED

#endif // def __GNUC__

#endif //ndef __COMPILER_EXTENSIONS__

// Local Variables:
// mode: c++
// c-basic-offset: 4
// case-replace: nil
// make-backup-files: t
// End:
