// record.h
//
// Created 1998 by Karri-Pekka Laakso
//
// $Id: record.h,v 1.5 1999/08/10 12:19:21 jks Exp $
//

#ifndef RECORD_H
#define RECORD_H

#include <string>
using namespace std;

#include "scanner.h"

/** A class for record definitions of the model.

    This virtual class defines the part of the common record interface
    that is independent of record types. The generated records have
    other common functions than are listed here, but they cannot be
    part of this interface, because they have different argument or
    return types. */
class record {
protected:
    /** The name of this record. The name is defined in the data or it 
	is generated from the links of this record. */
    string name;
  

public:
    /// Constructor.
    record(const string &n) : name(n) {}

    /** Creates all the variables of this record. */
    virtual void createVariables() = 0;
    /** Initializes the links between records. */
    virtual void initLinks() = 0;
    /** Initializes the fields of the records for simulation. */
    virtual void initialize() = 0;

    /** Destructor. */
    virtual ~record() {}
};

#endif // RECORD_H


// Local Variables:
// mode: c++
// make-backup-files: t
// c-basic-offset: 4
// End:
