
/*  A Bison parser, made from ./parse-bassist.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse yyparse
#define yylex yylex
#define yyerror yyerror
#define yylval yylval
#define yychar yychar
#define yydebug yydebug
#define yynerrs yynerrs
#define	ID	257
#define	FLOAT	258
#define	MODEL	259
#define	VAR	260
#define	RECORD	261
#define	REF	262
#define	AS	263
#define	PREDICTED	264
#define	DISTRIBUTION	265
#define	IMPLEMENTATION	266
#define	INIT	267
#define	PRIOR	268
#define	PROPOSE	269
#define	UPDATE	270
#define	ORDERED	271
#define	UNORDERED	272
#define	AGGR_SUM	273
#define	AGGR_PRODUCT	274
#define	AGGR_MIN	275
#define	AGGR_MAX	276
#define	AGGR_AVG	277
#define	AGGR_COUNT	278
#define	UMINUS	279
#define	PAREN	280

#line 1 "./parse-bassist.y"

// parse-bassist.y
//
// Created 1998 by Karri-Pekka Laakso
//
// $Modified: Fri Aug 28 08:37:17 1998 kpalaaks$
// $Id: parse-bassist.y,v 1.24 1999/10/26 10:19:41 jks Exp $
//

#include <vector>
#include <cstdio>
using namespace std;

#include "common.h"
#include "main.h"
#include "expr.h"
#include "record.h"
#include "variable.h"
#include "implementation.h"
#include "distribution.h"

#define YYDEBUG 1

extern FILE *yyin;
static char **filenames;
extern "C" int yywrap();

// We want line numbers relative to the beginning of this file,
// not across files: yylineno-baselineno+1
extern int yylineno;
static int baselineno;

int
bassist_lineno()
{
    return yylineno-baselineno+1;
}

int 
yyerror(char *msg)
{
    extern int yylineno;
    extern char *yytext;

    c.parse_errors = true;

    outputDiagnostic("%s:%d: %s -- token %s",
		     c.datafile.c_str(), bassist_lineno(), msg, yytext);
    return 0;
}

variable *
resolveVariable(const string &name)
{
    vector<variable*>::iterator
	i = c.variables->begin(),
	end = c.variables->end();
    for (; i != end; i++)
	if ((*i)->giveName() == name)
	    return (*i);
    c.parse_error("undefined variable: %s", name.c_str());
    return 0;
}

variable *
resolveVariable(const string &rec, const string &field)
{
    record *theRecord = 0;

    vector<record*>::iterator
	i = c.records->begin(),
	end = c.records->end();
    for (; i != end; i++)
	if ((*i)->giveName() == rec) {
	    theRecord = *i;
	    break;
	}
    if (theRecord != 0) {
	vector<variable*>::iterator
	    i = theRecord->allFields()->begin(),
	    end = theRecord->allFields()->end();
	for (; i != end; i++)
	    if ((*i)->giveName() == field)
		return (*i);
    }
    c.parse_error("undefined variable: %s.%s", rec.c_str(), field.c_str());
    return 0;
}

extern int yylex(void);



#line 97 "./parse-bassist.y"
typedef union {
    string *s;
    int i;
    double f;
    bool b;
    expr *e;
    vector<expr*> *le;
    vector<variable*> *ln;
    record *r;
    variable *v;
    recordRef *rr;
    distributionRef *dr;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		153
#define	YYFLAG		-32768
#define	YYNTBASE	41

#define YYTRANSLATE(x) ((unsigned)(x) <= 280 ? yytranslate[x] : 72)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    33,
    34,    28,    26,    25,    27,    40,    29,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    39,    32,     2,
    35,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    37,     2,    38,    36,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    30,    31
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     4,    10,    14,    15,    18,    21,    23,    26,
    29,    31,    39,    40,    42,    46,    52,    57,    60,    65,
    66,    73,    74,    83,    85,    86,    87,    91,    93,    95,
    98,   103,   107,   109,   113,   117,   121,   125,   128,   132,
   134,   139,   141,   143,   145,   146,   150,   152,   157,   164,
   171,   178,   185,   192,   196,   199,   203,   205,   207,   209,
   210,   216,   221,   222,   228,   229,   235,   240,   243,   246,
   250
};

static const short yyrhs[] = {    43,
    44,     0,     0,    43,    44,    62,    42,    63,     0,     5,
     3,    32,     0,     0,    44,    45,     0,    48,    32,     0,
    50,     0,    56,    32,     0,    46,    32,     0,    32,     0,
    11,     3,    33,    47,    34,    35,     3,     0,     0,     3,
     0,    47,    25,     3,     0,     6,     3,    36,    49,    53,
     0,     6,     3,    35,    58,     0,     6,     3,     0,     3,
    33,    59,    34,     0,     0,     7,     3,    37,    51,    54,
    38,     0,     0,     7,     3,    39,     3,    37,    52,    54,
    38,     0,    10,     0,     0,     0,    54,    55,    32,     0,
    48,     0,    56,     0,     8,     3,     0,     8,     3,     9,
     3,     0,     3,    40,     3,     0,     3,     0,    58,    26,
    58,     0,    58,    27,    58,     0,    58,    28,    58,     0,
    58,    29,    58,     0,    27,    58,     0,    33,    58,    34,
     0,    57,     0,     3,    33,    59,    34,     0,    61,     0,
     4,     0,    60,     0,     0,    60,    25,    58,     0,    58,
     0,    24,    33,     3,    34,     0,    19,    33,     3,    40,
     3,    34,     0,    20,    33,     3,    40,     3,    34,     0,
    21,    33,     3,    40,     3,    34,     0,    22,    33,     3,
    40,     3,    34,     0,    23,    33,     3,    40,     3,    34,
     0,    12,     3,    32,     0,    64,    32,     0,    63,    64,
    32,     0,    65,     0,    68,     0,    70,     0,     0,    13,
    71,    36,    66,    49,     0,    13,    71,    36,    14,     0,
     0,    13,    71,    35,    67,    58,     0,     0,    15,    71,
    36,    69,    49,     0,    15,    71,    36,    14,     0,    16,
    17,     0,    16,    18,     0,     3,    40,     3,     0,     3,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   135,   137,   138,   142,   145,   146,   149,   150,   151,   152,
   153,   156,   165,   166,   167,   170,   172,   173,   176,   179,
   183,   186,   190,   195,   196,   199,   200,   203,   204,   207,
   208,   211,   212,   215,   216,   217,   218,   219,   220,   221,
   222,   223,   224,   227,   228,   231,   232,   235,   238,   240,
   242,   244,   246,   250,   253,   254,   257,   258,   259,   262,
   263,   265,   266,   267,   271,   273,   277,   281,   282,   285,
   286
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ID","FLOAT",
"MODEL","VAR","RECORD","REF","AS","PREDICTED","DISTRIBUTION","IMPLEMENTATION",
"INIT","PRIOR","PROPOSE","UPDATE","ORDERED","UNORDERED","AGGR_SUM","AGGR_PRODUCT",
"AGGR_MIN","AGGR_MAX","AGGR_AVG","AGGR_COUNT","','","'+'","'-'","'*'","'/'",
"UMINUS","PAREN","';'","'('","')'","'='","'~'","'{'","'}'","':'","'.'","model_start",
"@1","model_id","model_definition","definition","distribution_def","dist_param_list",
"variable_def","distribution_ref","record_def","@2","@3","predicted","record_fields",
"record_field","record_ref","variable_ref","expr","param_list","expr_list","aggregate_function_call",
"implementation_id","implementation_specification","impl_clause","init_clause",
"@4","@5","proposal_clause","@6","update_clause","impl_var_ref", NULL
};
#endif

static const short yyr1[] = {     0,
    41,    42,    41,    43,    44,    44,    45,    45,    45,    45,
    45,    46,    47,    47,    47,    48,    48,    48,    49,    51,
    50,    52,    50,    53,    53,    54,    54,    55,    55,    56,
    56,    57,    57,    58,    58,    58,    58,    58,    58,    58,
    58,    58,    58,    59,    59,    60,    60,    61,    61,    61,
    61,    61,    61,    62,    63,    63,    64,    64,    64,    66,
    65,    65,    67,    65,    69,    68,    68,    70,    70,    71,
    71
};

static const short yyr2[] = {     0,
     2,     0,     5,     3,     0,     2,     2,     1,     2,     2,
     1,     7,     0,     1,     3,     5,     4,     2,     4,     0,
     6,     0,     8,     1,     0,     0,     3,     1,     1,     2,
     4,     3,     1,     3,     3,     3,     3,     2,     3,     1,
     4,     1,     1,     1,     0,     3,     1,     4,     6,     6,
     6,     6,     6,     3,     2,     3,     1,     1,     1,     0,
     5,     4,     0,     5,     0,     5,     4,     2,     2,     3,
     1
};

static const short yydefact[] = {     0,
     0,     5,     0,     1,     4,     0,     0,     0,     0,     0,
    11,     6,     0,     0,     8,     0,     2,    18,     0,    30,
     0,     0,    10,     7,     9,     0,     0,     0,    20,     0,
     0,    13,    54,     0,     0,     0,     3,     0,    57,    58,
    59,    33,    43,     0,     0,     0,     0,     0,     0,     0,
     0,    40,    17,    42,     0,    25,    26,     0,    31,    14,
     0,    71,     0,     0,    68,    69,     0,    55,    45,     0,
     0,     0,     0,     0,     0,     0,    38,     0,     0,     0,
     0,     0,    45,    24,    16,     0,    22,     0,     0,     0,
    63,    60,    65,    56,    47,     0,    44,    32,     0,     0,
     0,     0,     0,     0,    39,    34,    35,    36,    37,     0,
    21,    28,     0,    29,    26,    15,     0,    70,     0,    62,
     0,    67,     0,    41,     0,     0,     0,     0,     0,     0,
    48,    19,    27,     0,    12,    64,    61,    66,    46,     0,
     0,     0,     0,     0,    23,    49,    50,    51,    52,    53,
     0,     0,     0
};

static const short yydefgoto[] = {   151,
    26,     2,     4,    12,    13,    61,   112,    56,    15,    57,
   115,    85,    86,   113,   114,    52,    95,    96,    97,    54,
    17,    37,    38,    39,   121,   119,    40,   123,    41,    63
};

static const short yypact[] = {     0,
    18,-32768,     5,     7,-32768,    37,    48,    59,    60,    61,
-32768,-32768,    33,    34,-32768,    35,-32768,   -10,   -17,    62,
    36,    38,-32768,-32768,-32768,    -7,     8,    65,-32768,    69,
    70,    71,-32768,    72,    72,    39,    -7,    44,-32768,-32768,
-32768,   -23,-32768,    45,    46,    47,    49,    50,    51,     8,
     8,-32768,    20,-32768,    52,    67,-32768,    53,-32768,-32768,
   -18,    41,    23,    55,-32768,-32768,    54,-32768,     8,    84,
    85,    86,    90,    91,    92,    93,-32768,    16,     8,     8,
     8,     8,     8,-32768,-32768,    -5,-32768,    94,    64,    97,
-32768,    87,    88,-32768,    20,    73,    78,-32768,    66,    68,
    74,    75,    76,    77,-32768,    32,    32,-32768,-32768,    79,
-32768,-32768,    80,-32768,-32768,-32768,   101,-32768,     8,-32768,
    65,-32768,    65,-32768,     8,   102,   106,   107,   114,   115,
-32768,-32768,-32768,    -4,-32768,    20,-32768,-32768,    20,    89,
    95,    96,    98,    99,-32768,-32768,-32768,-32768,-32768,-32768,
   119,   120,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   117,   -85,-32768,-32768,
-32768,-32768,     9,-32768,   118,-32768,   -27,    42,-32768,-32768,
-32768,-32768,   100,-32768,-32768,-32768,-32768,-32768,-32768,   103
};


#define	YYLAST		138


static const short yytable[] = {    53,
     6,     6,     8,     8,     1,    34,    88,    35,    36,    69,
    42,    43,     6,     7,     8,    89,    70,     9,    10,    29,
     3,    30,    77,    78,    27,    28,    44,    45,    46,    47,
    48,    49,   111,   145,    50,   137,     5,   138,    11,    18,
    51,    79,    80,    81,    82,    79,    80,    81,    82,   105,
    19,   106,   107,   108,   109,    65,    66,    91,    92,    81,
    82,    20,    21,    22,    23,    24,    25,    55,    32,    33,
    31,    58,    59,    60,    62,    68,    84,    71,    72,    73,
    90,    74,    75,    76,    83,    94,    98,    99,   100,    87,
    93,   136,   101,   102,   103,   104,   116,   139,   117,   118,
   120,   122,   125,   135,   140,   126,   124,   127,   141,   142,
   131,   133,   132,   128,   129,   130,   143,   144,   152,   153,
    14,    16,   146,   134,   110,     0,     0,     0,   147,   148,
     0,   149,   150,     0,     0,     0,    67,    64
};

static const short yycheck[] = {    27,
     6,     6,     8,     8,     5,    13,    25,    15,    16,    33,
     3,     4,     6,     7,     8,    34,    40,    11,    12,    37,
     3,    39,    50,    51,    35,    36,    19,    20,    21,    22,
    23,    24,    38,    38,    27,   121,    32,   123,    32,     3,
    33,    26,    27,    28,    29,    26,    27,    28,    29,    34,
     3,    79,    80,    81,    82,    17,    18,    35,    36,    28,
    29,     3,     3,     3,    32,    32,    32,     3,    33,    32,
     9,     3,     3,     3,     3,    32,    10,    33,    33,    33,
    40,    33,    33,    33,    33,    32,     3,     3,     3,    37,
    36,   119,     3,     3,     3,     3,     3,   125,    35,     3,
    14,    14,    25,     3,     3,    40,    34,    40,     3,     3,
    34,    32,    34,    40,    40,    40,     3,     3,     0,     0,
     4,     4,    34,   115,    83,    -1,    -1,    -1,    34,    34,
    -1,    34,    34,    -1,    -1,    -1,    37,    35
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 135 "./parse-bassist.y"
{ c.doInheritance();
						  outputDiagnostic("Warning: missing implementation specification"); ;
    break;}
case 2:
#line 137 "./parse-bassist.y"
{ c.doInheritance(); ;
    break;}
case 3:
#line 138 "./parse-bassist.y"
{ ;
    break;}
case 4:
#line 142 "./parse-bassist.y"
{ c.setModelName(*yyvsp[-1].s); delete yyvsp[-1].s; ;
    break;}
case 7:
#line 149 "./parse-bassist.y"
{ c.variables->push_back(yyvsp[-1].v); ;
    break;}
case 8:
#line 150 "./parse-bassist.y"
{ c.records->push_back(yyvsp[0].r); ;
    break;}
case 9:
#line 151 "./parse-bassist.y"
{ c.references->push_back(yyvsp[-1].rr); ;
    break;}
case 10:
#line 152 "./parse-bassist.y"
{ ;
    break;}
case 11:
#line 153 "./parse-bassist.y"
{ ;
    break;}
case 12:
#line 157 "./parse-bassist.y"
{ distributionDefinition::newDistribution(
            new distributionDefinition(*yyvsp[-5].s, yyvsp[-3].i, *yyvsp[0].s, false));
	  delete yyvsp[-5].s; delete yyvsp[0].s;
	;
    break;}
case 13:
#line 165 "./parse-bassist.y"
{ yyval.i = 0; ;
    break;}
case 14:
#line 166 "./parse-bassist.y"
{ yyval.i = 1; ;
    break;}
case 15:
#line 167 "./parse-bassist.y"
{ yyval.i = yyvsp[-2].i + 1; ;
    break;}
case 16:
#line 171 "./parse-bassist.y"
{ yyval.v = new stochasticVar(*yyvsp[-3].s, yyvsp[-1].dr, yyvsp[0].b); delete yyvsp[-3].s; ;
    break;}
case 17:
#line 172 "./parse-bassist.y"
{ yyval.v = new determVar(*yyvsp[-2].s, yyvsp[0].e); delete yyvsp[-2].s; ;
    break;}
case 18:
#line 173 "./parse-bassist.y"
{ yyval.v = new variable(*yyvsp[0].s); delete yyvsp[0].s; ;
    break;}
case 19:
#line 176 "./parse-bassist.y"
{ yyval.dr = new distributionRef(*yyvsp[-3].s, yyvsp[-1].le); delete yyvsp[-3].s; ;
    break;}
case 20:
#line 179 "./parse-bassist.y"
{ yyval.r = new record(*yyvsp[-1].s, new vector<variable*>);
                                                  delete yyvsp[-1].s;
						  c.localRecord = yyval.r;
						;
    break;}
case 21:
#line 183 "./parse-bassist.y"
{ yyval.r = c.localRecord;
						  c.localRecord = 0;
						;
    break;}
case 22:
#line 186 "./parse-bassist.y"
{ yyval.r = new record(*yyvsp[-3].s, *yyvsp[-1].s, new vector<variable*>);
						  delete yyvsp[-3].s; delete yyvsp[-1].s;
						  c.localRecord = yyval.r;
						;
    break;}
case 23:
#line 190 "./parse-bassist.y"
{ yyval.r = c.localRecord;
						  c.localRecord = 0;
						;
    break;}
case 24:
#line 195 "./parse-bassist.y"
{ yyval.b = true; ;
    break;}
case 25:
#line 196 "./parse-bassist.y"
{ yyval.b = false; ;
    break;}
case 26:
#line 199 "./parse-bassist.y"
{ yyval.ln = c.localRecord->allFields(); ;
    break;}
case 27:
#line 200 "./parse-bassist.y"
{ yyvsp[-2].ln->push_back(yyvsp[-1].v); ;
    break;}
case 28:
#line 203 "./parse-bassist.y"
{ yyval.v = yyvsp[0].v; ;
    break;}
case 29:
#line 204 "./parse-bassist.y"
{ yyval.v = yyvsp[0].rr; ;
    break;}
case 30:
#line 207 "./parse-bassist.y"
{ yyval.rr = new recordRef(*yyvsp[0].s); delete yyvsp[0].s; ;
    break;}
case 31:
#line 208 "./parse-bassist.y"
{ yyval.rr = new recordRef(*yyvsp[-2].s, *yyvsp[0].s); delete yyvsp[-2].s; ;
    break;}
case 32:
#line 211 "./parse-bassist.y"
{ yyval.e = new variableRef(*yyvsp[-2].s, *yyvsp[0].s); delete yyvsp[-2].s; delete yyvsp[0].s; ;
    break;}
case 33:
#line 212 "./parse-bassist.y"
{ yyval.e = new variableRef(*yyvsp[0].s); delete yyvsp[0].s;;
    break;}
case 34:
#line 215 "./parse-bassist.y"
{ yyval.e = new arithmeticExpr(yyvsp[-2].e, PLUS, yyvsp[0].e); ;
    break;}
case 35:
#line 216 "./parse-bassist.y"
{ yyval.e = new arithmeticExpr(yyvsp[-2].e, MINUS, yyvsp[0].e); ;
    break;}
case 36:
#line 217 "./parse-bassist.y"
{ yyval.e = new arithmeticExpr(yyvsp[-2].e, MULT, yyvsp[0].e); ;
    break;}
case 37:
#line 218 "./parse-bassist.y"
{ yyval.e = new arithmeticExpr(yyvsp[-2].e, DIV, yyvsp[0].e); ;
    break;}
case 38:
#line 219 "./parse-bassist.y"
{ yyval.e = new negationExpr(yyvsp[0].e); ;
    break;}
case 39:
#line 220 "./parse-bassist.y"
{ yyval.e = new parenExpr(yyvsp[-1].e); ;
    break;}
case 40:
#line 221 "./parse-bassist.y"
{ yyval.e = yyvsp[0].e; ;
    break;}
case 41:
#line 222 "./parse-bassist.y"
{ yyval.e = new functionCall(*yyvsp[-3].s, yyvsp[-1].le); delete yyvsp[-3].s; ;
    break;}
case 42:
#line 223 "./parse-bassist.y"
{ yyval.e = yyvsp[0].e; ;
    break;}
case 43:
#line 224 "./parse-bassist.y"
{ yyval.e = new constant(yyvsp[0].f); ;
    break;}
case 44:
#line 227 "./parse-bassist.y"
{ yyval.le = yyvsp[0].le; ;
    break;}
case 45:
#line 228 "./parse-bassist.y"
{ yyval.le = new vector<expr*>; /* Empty paramlist */;
    break;}
case 46:
#line 231 "./parse-bassist.y"
{ yyvsp[-2].le->push_back(yyvsp[0].e); ;
    break;}
case 47:
#line 232 "./parse-bassist.y"
{ yyval.le = new vector<expr*>; yyval.le->push_back(yyvsp[0].e); ;
    break;}
case 48:
#line 236 "./parse-bassist.y"
{ yyval.e = new aggregateFunctionCall("count", *yyvsp[-1].s); 
	                                  delete yyvsp[-1].s; ;
    break;}
case 49:
#line 238 "./parse-bassist.y"
{ yyval.e = new aggregateFunctionCall("sum", *yyvsp[-3].s, *yyvsp[-1].s);
	                                  delete yyvsp[-3].s; delete yyvsp[-1].s; ;
    break;}
case 50:
#line 240 "./parse-bassist.y"
{ yyval.e = new aggregateFunctionCall("product", *yyvsp[-3].s, *yyvsp[-1].s);
	                                  delete yyvsp[-3].s; delete yyvsp[-1].s; ;
    break;}
case 51:
#line 242 "./parse-bassist.y"
{ yyval.e = new aggregateFunctionCall("min", *yyvsp[-3].s, *yyvsp[-1].s);
	                                  delete yyvsp[-3].s; delete yyvsp[-1].s; ;
    break;}
case 52:
#line 244 "./parse-bassist.y"
{ yyval.e = new aggregateFunctionCall("max", *yyvsp[-3].s, *yyvsp[-1].s);
	                                  delete yyvsp[-3].s; delete yyvsp[-1].s; ;
    break;}
case 53:
#line 246 "./parse-bassist.y"
{ yyval.e = new aggregateFunctionCall("avg", *yyvsp[-3].s, *yyvsp[-1].s);
	                                  delete yyvsp[-3].s; delete yyvsp[-1].s; ;
    break;}
case 54:
#line 250 "./parse-bassist.y"
{ c.checkModelName(*yyvsp[-1].s); delete yyvsp[-1].s; ;
    break;}
case 59:
#line 259 "./parse-bassist.y"
{ outputDiagnostic("Warning: update clauses unimplemented"); /*FIXME*/;
    break;}
case 60:
#line 262 "./parse-bassist.y"
{ c.localRecord = yyvsp[-1].v->giveRecord(); ;
    break;}
case 61:
#line 263 "./parse-bassist.y"
{ yyvsp[-3].v->addInitClause(new randomInitializationClause(yyvsp[0].dr, yyvsp[-3].v)); 
				     c.localRecord = 0; ;
    break;}
case 62:
#line 265 "./parse-bassist.y"
{ yyvsp[-2].v->addInitClause(0); ;
    break;}
case 63:
#line 266 "./parse-bassist.y"
{ c.localRecord = yyvsp[-1].v->giveRecord(); ;
    break;}
case 64:
#line 267 "./parse-bassist.y"
{ yyvsp[-3].v->addInitClause(new constantInitializationClause(yyvsp[0].e, yyvsp[-3].v)); 
	         c.localRecord = 0; ;
    break;}
case 65:
#line 271 "./parse-bassist.y"
{ c.localRecord = yyvsp[-1].v->giveRecord(); 
					    c.proposalTargetVariable = yyvsp[-1].v; ;
    break;}
case 66:
#line 273 "./parse-bassist.y"
{ if (yyvsp[-3].v != 0) 
					yyvsp[-3].v->addProposalClause(new proposalClause(yyvsp[0].dr, yyvsp[-3].v)); 
				      c.localRecord = 0; 
				      c.proposalTargetVariable = 0; ;
    break;}
case 67:
#line 278 "./parse-bassist.y"
{ if (yyvsp[-2].v != 0) yyvsp[-2].v->addProposalClause(); ;
    break;}
case 70:
#line 285 "./parse-bassist.y"
{ yyval.v = resolveVariable(*yyvsp[-2].s, *yyvsp[0].s); delete yyvsp[-2].s; delete yyvsp[0].s; ;
    break;}
case 71:
#line 286 "./parse-bassist.y"
{ yyval.v = resolveVariable("", *yyvsp[0].s); delete yyvsp[0].s; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 289 "./parse-bassist.y"


int
yywrap()
{
    // Close former input file. 
    // By default, yyin==stdin according to some documentation, 
    // but it seems to be ==0 in our implementation.
    if (yyin != stdin && yyin != 0) { 
	fclose(yyin);
    }
    yyin = 0;

    // Open consecutive files until there are no more files
    // or opening one file succeeds.
    while (*filenames != 0 && yyin == 0) {
	yyin = fopen(*filenames, "r");
	if (yyin == 0) {
	    outputDiagnostic(true, "Cannot open file \"%s\" for reading: ", 
			     *filenames++);
	} else {
	    // Succeeded
	    outputInformation("Reading file \"%s\"", *filenames);
	    c.datafile=*filenames++;
	    baselineno=yylineno;
	    return 0;
	}
    }

    ASSERT(*filenames == 0);

    // No more files
    c.datafile="";
    baselineno=yylineno;
    return 1;
}

void
parse_files(char **files)
{
    //yydebug = 1;
    filenames = files;

    if (yywrap() != 0) {		// Open the first file
	outputDiagnostic("No files to process");
	c.parse_errors = true;
	return;
    }

    yyparse();
}

// Local Variables:
// mode: c++
// c-basic-offset: 4
// case-replace: nil
// make-backup-files: t
// End:
